package _VisualDVM.TestingSystem.SAPFOR.SapforPackage.UI;
import Common.Database.Tables.DataSet;
import Common.Passes.PassCode_;
import Common.Visual.Controls.MenuBarButton;
import Common.Visual.FilterFlag;
import Common.Visual.Menus.DataMenuBar;
import Common.Visual.Tables.ColumnInfo;
import Common.Visual.Tables.RendererDate;
import Common.Visual.Tables.RendererMilliseconds;
import Common.Visual.Tables.RendererProgressBar;
import _VisualDVM.Global;
import _VisualDVM.Passes.PassCode;
import _VisualDVM.ServerObjectsCache.SapforPackageCache;
import _VisualDVM.ServerObjectsCache.VisualCaches;
import _VisualDVM.TestingSystem.Common.TasksPackageState;
import _VisualDVM.TestingSystem.SAPFOR.SapforPackage.SapforPackage;
import _VisualDVM.Visual.RDataSetControlForm;
import _VisualDVM.Visual.Tables.RendererDiff;
import _VisualDVM.Visual.Tables.RendererTestingPackageStatus;

import javax.swing.*;
import java.util.Comparator;
public class SapforPackagesForm extends RDataSetControlForm<SapforPackage> {
    public SapforPackagesForm(DataSet<?, SapforPackage> dataSource_in, JPanel mountPanel_in) {
        super(dataSource_in, mountPanel_in);
    }
    @Override
    protected void createColumns() {
        AddColumns(
                new ColumnInfo<SapforPackage>("автор") {
                    @Override
                    public Object getFieldAt(SapforPackage object) {
                        return object.sender_name;
                    }
                },
                new ColumnInfo<SapforPackage>("SAPFOR") {
                    @Override
                    public Object getFieldAt(SapforPackage object) {
                        return object.version;
                    }
                },
                new ColumnInfo<SapforPackage>("конфигурации") {
                    @Override
                    public Object getFieldAt(SapforPackage object) {
                        return ((SapforPackageCache) VisualCaches.GetCache(object)).confifurationsDescriptionsLine;
                    }
                },
                new ColumnInfo<SapforPackage>("задач") {
                    @Override
                    public Object getFieldAt(SapforPackage object) {
                        return object.tasksCount;
                    }
                },
                new ColumnInfo<SapforPackage>("ядер") {
                    @Override
                    public Object getFieldAt(SapforPackage object) {
                        return object.kernels;
                    }
                },
                new ColumnInfo<SapforPackage>("прогресс") {
                    @Override
                    public Object getFieldAt(SapforPackage object) {
                        return object.progress;
                    }
                    @Override
                    public Class getRendererClass() {
                        return RendererProgressBar.class;
                    }
                },
                new ColumnInfo<SapforPackage>("начало") {
                    @Override
                    public Object getFieldAt(SapforPackage object) {
                        return object.StartDate;
                    }
                    @Override
                    public Class getRendererClass() {
                        return RendererDate.class;
                    }
                },
                new ColumnInfo<SapforPackage>("изменено") {
                    @Override
                    public Object getFieldAt(SapforPackage object) {
                        return object.ChangeDate;
                    }
                    @Override
                    public Class getRendererClass() {
                        return RendererDate.class;
                    }
                },
                new ColumnInfo<SapforPackage>("время") {
                    @Override
                    public Object getFieldAt(SapforPackage object) {
                        return object.getMilliseconds();
                    }
                    @Override
                    public Class getRendererClass() {
                        return RendererMilliseconds.class;
                    }
                },
                new ColumnInfo<SapforPackage>("различия") {
                    @Override
                    public Object getFieldAt(SapforPackage object) {
                        return object.mismatchesCount;
                    }
                    @Override
                    public Class getRendererClass() {
                        return RendererDiff.class;
                    }
                },
                new ColumnInfo<SapforPackage>("статус") {
                    @Override
                    public Object getFieldAt(SapforPackage object) {
                        return object;
                    }
                    @Override
                    public Class getRendererClass() {
                        return RendererTestingPackageStatus.class;
                    }
                }
        );
    }
    @Override
    protected void MouseAction2() throws Exception {
        SelectAll(false);
        Global.mainModule.getPass(PassCode.CompareSapforPackages).Do();
    }
    @Override
    public PassCode_ getDeletePassCode() {
        return PassCode.DeleteSapforPackage;
    }
    @Override
    public DataMenuBar createMenuBar() {
        return new DataMenuBar(dataSource.getPluralDescription(), PassCode.SynchronizeTests) {
            {
                addSeparator();
                addPasses(PassCode.AbortSapforPackage);
                addSeparator();
                addPasses(PassCode.CompareSapforPackageToEthalon, PassCode.JoinSapforTestingVersionsToGroup
                        //   ,PassCode.RefreshSapforPackageResults
                );
                addSeparator();
                addPasses(PassCode.DeleteSapforPackage);
            }
        };
    }
    @Override
    protected Comparator<SapforPackage> getDefaultComparator() {
        return new Comparator<SapforPackage>() {
            @Override
            public int compare(SapforPackage o1, SapforPackage o2) {
                return o2.id - o1.id;
            }
        };
    }
    @Override
    protected void createFilters() {
        AddFilters(new FilterFlag<SapforPackage>(dataSource, new MenuBarButton() {
                       {
                           setText("Свои");
                           setToolTipText("Отображать только пакеты тестов авторства пользователя");
                       }
                   }, false) {
                       @Override
                       protected boolean validate(SapforPackage object) {
                           return Global.mainModule.getAccount().email.equals(object.sender_address);
                       }
                   },
                new FilterFlag<SapforPackage>(dataSource, new MenuBarButton() {
                    {
                        setText("Активные");
                        setToolTipText("Отображать только активные пакеты тестов");
                    }
                }, false) {
                    @Override
                    protected boolean validate(SapforPackage object) {
                        return object.state.isActive();
                    }
                },
                new FilterFlag<SapforPackage>(dataSource, new MenuBarButton() {
                    {
                        setText("С ошибками");
                        setToolTipText("Отображать только пакеты тестов с ошибками");
                    }
                }, false) {
                    @Override
                    protected boolean validate(SapforPackage object) {
                        return object.state.equals(TasksPackageState.DoneWithErrors);
                    }
                }
        );
    }
}
